%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HMMtype.m
% 
% Specify the type of HMM to use and the transition matrix is 
% altered accordingly. 
% Note: this function is not part of the HMM toolbox (Kevin Murphy).
% 
% Greg Eustace, MUMT 611, final project
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [y] = HMMtype (transmat, Q, type); 

y = transmat; 

%x = [1:5; 1:5; 1:5; 1:5; 1:5];

if type == 1 % Strict left-right matrix. Each state can transfer to its self and the next one.
	for i=1:Q
		if i == 1
		    y(1,3:Q) = 0;
		else
			y(i, 1:i-1) = 0;
			y(i, i+2:Q) = 0;
			y(Q,Q) = 1;
		end
	end
end

if type == 2 %left-right model. Each state can transfer to its self and any state to the right of it. 
	for i=2:Q
        y(i, 1:i-1) = 0;
		y(Q,Q) = 1;
    end
end

if type == 3 %left-right model. The last state can transfer to the first state. 
	for i=2:Q
        if i > Q
            y(i,1:i-1) = 0;
        else
            y(i,2:i-1) = 0;     
        end
    end
end